import { PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrDotmatrixtemplate {
  [PrimaryKeyProp]?: 'Id';
  Id!: bigint;
  Name?: string;
  Width!: number;
  Height!: number;
  DesignWidth!: number;
  DesignHeight!: number;
  OriginalImageUrl?: string;
  Elements?: any;
  Type!: number;
  Status!: number;
  Revision!: number;
  CreatedBy?: bigint;
  CreatedTime!: Date;
  UpdatedBy?: bigint;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const IcrDotmatrixtemplateSchema = defineEntity({
  class: IcrDotmatrixtemplate,
  comment: '点阵模板',
  properties: {
    Id: p.bigint().primary().name('Id').unsigned(false).autoincrement(false).comment('主键Id'),
    Name: p.string().name('Name').length(30).nullable().comment('答题板名称'),
    Width: p.float().name('Width').comment('宽毫米'),
    Height: p.float().name('Height').comment('高毫米'),
    DesignWidth: p.float().name('DesignWidth').comment('设计宽px'),
    DesignHeight: p.float().name('DesignHeight').comment('设计高px'),
    OriginalImageUrl: p.string().name('OriginalImageUrl').nullable().comment('原图(画板背景)'),
    Elements: p.json().name('Elements').nullable().comment('答题板元素'),
    Type: p.integer().name('Type').comment('类型'),
    Status: p.integer().name('Status').comment('状态'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
